clear all
clc
souboryx={'bod01' 'bod02' 'bod03' 'bod04' 'bod05' 'bod06' 'bod07' 'bod08' 'bod09' 'bod10' 'bod11' ... %první měření klapka otevřená a šroub s předpatím cca 40Nm
'bod12' 'bod13' 'bod14' 'bod15' 'bod16' 'bod17' 'bod18' 'bod19' 'bod20' 'bod21' 'bod22' 'bod23' 'bod24' ... %druhé měření klapka přivžená dle fotky a šroub utažen
'bod25' 'bod26' 'bod27' 'bod28' 'bod29' 'bod30' 'bod31' 'bod32' 'bod33' 'bod34' 'bod35' ... %třetí měření šroub povolen a klapka otevřená
'bod36' 'bod37' 'bod38' 'bod39' 'bod40' 'bod41' 'bod42' 'bod43' 'bod44' 'bod45' 'bod46' 'bod47' 'bod48'}; %poslední povolený šroub a přivřená klapka
%část názvu zdorjového souboru původní beze změny pro seřazení
p2xs=[8.1143 8.1222 8.1304 8.1379 8.1444 8.1545 8.1615 8.17 8.18 8.1888 8.2 ... %prvni mereni
    9.88 10.306 10.787 11.294 11.845 12.42 13.06 13.7 14.36 15.08 15.81 16.6 17.38 ... %druhe
    8.116 8.124 8.133 8.14 8.14 8.155 8.163 8.171 8.1795 8.188 8.196 ... %treti
    9.4192 9.727 10.08 10.453 10.816 11.224 11.67 12.136 12.615 13.13 13.66 14.26 14.98]; %čtvrte mereni mA

freks = (1:40); %rozsah analýzy RMS v kHz (1= 0-0,999kHz;1= 1-1,999kHz) fs je 100kHz tzn maximální analyzpvaná frekvence je 50kHz
% rozsahy=[7 11 31 35 20 24 43 47];
rozsahy=[1 11 12 22 25 35 36 46]; %prvni čtyři jsou hranice s otevřenou klapkou a druhé dva s přivřenou
for MERENI=1:4 %1:2 znamená pouze měření s otevřenou klapkou
    rozsah=(rozsahy(2*MERENI-1):rozsahy(2*MERENI))
    
freqs(:,:,MERENI)=repmat(freks,length(rozsah),1); %vytvoření meshgridu frekvencí
soubory=souboryx(rozsah);
p2s=p2xs(rozsah);
%% Poznámky
%1 - 1-11; 5.bod A2y - občasné přetížení; 6. A2y - trvale přetížen 
%7. A2x - trvale přetížen
%2 - 12-24; 18-začíná se ozývat kavitace na šroubu
%3 - 25-35;
%4 - 36-48;
%% Initialize variables.
for i=1:length(soubory); 
tic
soubor=char(soubory(i));
formatSpec = 'Zpracovává se soubor %s.\n';
fprintf(formatSpec,soubor)%Výpis co se zpracovává
a1='C:\Users\The_Guardian\Desktop\Diplomka\NAMERENA_DATA\1_mereni\'; %umístění zdrojových souborů
a2='.lvm';
    filename=strcat(a1,soubor,a2); %spojení umístění
delimiter = '\t';
startRow = 23;

% Format string for each line of text:
%   column2: double (%f)
%	column3: double (%f)
%   column4: double (%f)
%	column5: double (%f)
%   column6: double (%f)
%	column7: double (%f)
%   column8: double (%f)
%	column9: double (%f)
%   column10: double (%f)
% For more information, see the TEXTSCAN documentation.
formatSpec = '%*s%f%f%f%f%f%f%f%f%f%*s%[^\n\r]';

% Open the text file.
fileID = fopen(filename,'r');

% Read columns of data according to format string.
% This call is based on the structure of the file used to generate this
% code. If an error occurs for a different file, try regenerating the code
% from the Import Tool.
textscan(fileID, '%[^\n\r]', startRow-1, 'ReturnOnError', false);
dataArray = textscan(fileID, formatSpec, 'Delimiter', delimiter, 'EmptyValue' ,NaN,'ReturnOnError', false);

% Close the text file.
fclose(fileID);

%% Allocate imported array to column variable names
Q = dataArray{:, 2};
As = dataArray{:, 3};
pk2 = dataArray{:, 4};
pk1 = dataArray{:, 5};
a2x = dataArray{:, 6};
a2y = dataArray{:, 7};
a1x = dataArray{:, 8};
p1 = dataArray{:, 9};
P2(i)=(p2s(i)-4)/16*400; %přepočet z elektrické veličiny na tlak v kPa
%% Clear temporary variables
clearvars filename delimiter startRow formatSpec fileID ans;
%% Získání periody vzorku
delta=length(p1);
Fs=100000; %vzorkovací frekvence 100kHz
v_per=1/Fs; %vzorkovací perioda
stop_t=delta/Fs; %čas konce záznamu
t=(v_per:v_per:stop_t)'; %vektor času

%% Střední hodnoty
P1(i)=mean(p1); %kPa
% P2(i)=mean(p2);%kPa
Qa(i)=mean(Q);
Qas=repmat(Qa,40,1);
dP(i)=P1(i)-P2(i);%tlakový spád v kPa
TlakP1(i,MERENI)=P1(i);
TlakP2(i,MERENI)=P2(i);
%% Tlak syté páry
T=20;
Syta=[5.52444444444439e-05 0.000675666666666698 0.0517257936507932 0.589000000000002];
pp(i)=polyval(Syta,T); %kPa
%% Thommovo číslo
Sigma(i)=(P2(i)-pp(i))/(P1(i)-P2(i));
%% FFT a RMS z jednotlivých frekvencí
for prom=1:6;
promenna = dataArray{:, 2+prom}; %tzn 3 As,4 pk2,5 pk1,6 a2x,7 a2y,8 a1x
FT=fft(promenna);
Four(i,:)=FT;
for frek=freks;
    pomer=round(delta/Fs);
    Bod_start=(frek-1)*1000*pomer;
    Bod_stop=(frek*1000-1)*pomer;
    Bod_start2=delta-Bod_stop;
    Bod_stop2=delta-Bod_start;
    FTa=FT;
    FTa(1:Bod_start)=0;
    FTa(Bod_stop:Bod_start2)=0;
    FTa(Bod_stop2:end)=0;
    RMS_f(frek,i,prom) = sqrt(sum(abs(FTa/length(FTa)).^2));

end
end
toc
end

Qass(:,:,MERENI)=Qas;
RMS_F(:,:,:,MERENI)=RMS_f;
end
%% Odsun vakreslení pokud by nízké frekvence moc zastinovaly vyšší
odsun = 2;%kHz odsun od 0 kdy se začne vyhodnocovat RMS
if (odsun>0)
RMS_F(1:odsun,:,:,:)=0;
end

% %% Vykreslení do grafu
% popisek={'Utažený šroub','Povolený šroub'};
% jmena={'Acc Sroub' 'Kist 2' 'Kist 1' 'Acc 2X' 'Acc 2Y' 'Acc 1X'};
% popisky={'Zrychlení [g]' 'Tlak [kPa]' 'Tlak [kPa]' 'Zrychlení [g]' 'Zrychlení [g]' 'Zrychlení [g]'};
% for i=1:6
%     figure('Name',jmena{i});
%     jmeno=jmena(i);
% subplot(5,2,[1 3 5 7])
% plot3(Qass(:,:,1),freqs(:,:,1)',RMS_F(:,:,i,1),'b',Qass(:,:,3),freqs(:,:,3)',RMS_F(:,:,i,3),'r')%,'linewidth',1.5)
% title('Klapka plně otevřena');
% 
% xlabel('Prutok [l/s]')
% ylabel('Frekvence [kHz]')
% zlabel(popisky(i))
% % axis([0 inf 0 40 0 inf])
% view([120 20]);
% set(gca,'YTick',[1 5 10 20 40])
% set(gca,'YTickLabel',{'10-999 Hz','4-5 kHz','9-10 kHz','19-20 kHz','39-40 kHz'})
% 
% subplot(5,2,[2 4 6 8])
% plot3(Qass(:,:,2),freqs(:,:,2)',RMS_F(:,:,i,2),'b',Qass(:,:,4),freqs(:,:,4)',RMS_F(:,:,i,4),'r')%,'linewidth',1.5)
% title('Klapka přivřena');
% 
% xlabel('Prutok [l/s]')
% ylabel('Frekvence [kHz]')
% zlabel(popisky(i))
% % axis([0 inf 0 40 0 inf])
% view([120 20]);
% set(gca,'YTick',[1 5 10 20 40])
% set(gca,'YTickLabel',{'10-999 Hz','4-5 kHz','9-10 kHz','19-20 kHz','39-40 kHz'})
% subplot(5,2,[9 10])
% text(0.1,0.5,'Sroub utazeny','Color','blue','FontSize',14)
% text(0.6,0.5,'Sroub povoleny','Color','red','FontSize',14)
% 
% 
% hold on
% end



